## open-iscsi 2.0.730

=== Makefile ===
#
# Makefile for the Open-iSCSI Initiator
#

# if you are packaging open-iscsi, set this variable to the location
# that you want everything installed into.
DESTDIR ?= 

prefix = /usr
exec_prefix = /
sbindir = $(exec_prefix)/sbin
bindir = $(exec_prefix)/bin
mandir = $(prefix)/share/man
etcdir = /etc
initddir = $(etcdir)/init.d

MANPAGES = doc/iscsid.8 doc/iscsiadm.8 doc/iscsi_discovery.8
PROGRAMS = usr/iscsid usr/iscsiadm utils/iscsi_discovery
INSTALL = install
ETCFILES = etc/iscsid.conf

# Random comments:
# using '$(MAKE)' instead of just 'make' allows make to run in parallel
# over multiple makefile.

all:
	$(MAKE) -C usr
	$(MAKE) -C kernel
	@echo
	@echo "Compilation complete                Output file"
	@echo "----------------------------------- ----------------"
	@echo "Built iSCSI Open Interface module:  kernel/scsi_transport_iscsi.ko"
	@echo "Built iSCSI library module:         kernel/libiscsi.ko"
	@echo "Built iSCSI over TCP kernel module: kernel/iscsi_tcp.ko"
	@echo "Built iSCSI daemon:                 usr/iscsid"
	@echo "Built management application:       usr/iscsiadm"
	@echo
	@echo Read README file for detailed information.

clean:
	$(MAKE) -C usr clean
	$(MAKE) -C kernel clean

# this is for safety
# now -jXXX will still be safe
# note that make may still execute the blocks in parallel
.NOTPARALLEL: install_usr install_programs install_initd \
	install_initd_suse install_initd_redhat install_initd_debian \
	install_etc install_doc install_kernel

install: install_kernel install_programs install_doc install_etc \
	install_initd

install_programs:  $(PROGRAMS)
	$(INSTALL) -d $(DESTDIR)$(sbindir)
	$(INSTALL) -m 755 $^ $(DESTDIR)$(sbindir)

# ugh, auto-detection is evil
# Gentoo maintains their own init.d stuff
install_initd:
	if [ -f /etc/debian_version ]; then \
		$(MAKE) install_initd_debian ; \
	elif [ -f /etc/redhat-release ]; then \
		$(MAKE) install_initd_redhat ; \
	elif [ -f /etc/SuSE-release ]; then \
		$(MAKE) install_initd_suse ; \
	fi

# these are external targets to allow bypassing distribution detection
install_initd_suse:
	$(INSTALL) -d $(DESTDIR)$(initddir)
	$(INSTALL) -m 755 etc/initd/initd.suse \
		$(DESTDIR)$(initddir)/open-iscsi

install_initd_redhat:
	$(INSTALL) -d $(DESTDIR)$(initddir)
	$(INSTALL) -m 755 etc/initd/initd.redhat \
		$(DESTDIR)$(initddir)/open-iscsi

install_initd_debian:
	$(INSTALL) -d $(DESTDIR)$(initddir)
	$(INSTALL) -m 755 etc/initd/initd.debian \
		$(DESTDIR)$(initddir)/open-iscsi

install_etc: $(ETCFILES)
	$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi
	$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi

install_doc: $(MANPAGES)
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL) -m 644 $^ $(DESTDIR)$(mandir)/man8

install_kernel:
	$(MAKE) -C kernel install_kernel

# vim: ft=make tw=72 sw=4 ts=4:

=== kernel/Makefile ===
#
# Makefile for the Linux Kernel iSCSI Initiator
#
# This Makefile invokes KBuild from outside the kernel directory when
# used from the main open-iscsi package. It also contains all of the
# KBuild stuff needed to build the the modules.
#

# Kbuild stuff, the following is the only part of this file that KBuild
# actually uses itself.
EXTRA_CFLAGS += -I$(obj) -I$(obj)/../include 

ifeq ($(DEBUG_SCSI), 1)
EXTRA_CFLAGS += -DDEBUG_SCSI=1
endif

ifeq ($(DEBUG_TCP), 1)
EXTRA_CFLAGS += -DDEBUG_TCP=1
endif

obj-m				+= scsi_transport_iscsi.o
obj-m				+= libiscsi.o
obj-m				+= iscsi_tcp.o

# Everything beyond this point is used to call KBuild or handle support
# for multiple kernel versions.

# Kbuild verbosity
V ?= 0

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build
KBUILD_OUTPUT ?= 
# this is the basic Kbuild invocation, just append your make target
KBUILD_BASE = +$(MAKE) -C $(KSRC) M=`pwd` KBUILD_OUTPUT=$(KBUILD_OUTPUT) $(KARCH) V=$(V)

# fun stuff for maintaining multiple versions
KSUBLEVEL = $(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
		sed 's/^[ \t]*//;s/[ \t]*$$//')

ifeq ($(KSUBLEVEL), 11)
EXTRA_CFLAGS += -DNETLINK_ISCSI=12
else
ifeq ($(KSUBLEVEL), 12)
EXTRA_CFLAGS += -DNETLINK_ISCSI=12
endif
endif

all: kernel_check
	$(KBUILD_BASE) modules

# ====== BEGIN code for kernel_check


# generic make function
# syntax:
# @$(call generic_check_command, CHECKING-COMMAND, PATCHNAME)
generic_check_command = if $(1) ; then \
				echo "kernel check... FAILED"; \
				echo "Apply the $(2) first!"; exit 1; fi ; \
				echo "kernel check... OK"

# this variable defines how we check for iscsi_compat
check_iscsi_compat_command =  ! grep iscsi_compat scsi_transport_iscsi.c >/dev/null 
# this variable is the actual make function
check_iscsi_compat = $(call generic_check_command, $(check_iscsi_compat_command), $(1))
# syntax:
# @$(call check_iscsi_compat, PATCHNAME)

# this if-else ladder is horrible
# but I don't know any quick way to clean it up
# since Make doesn't support a switch construct
.NOTPARALLEL: kernel_check
kernel_check:
ifeq ($(KSUBLEVEL),16)
	echo "kernel check... OK"
else
ifeq ($(KSUBLEVEL),17)
	echo "kernel check... OK"
else
ifeq ($(KSUBLEVEL),18)
	echo "kernel check... OK"
else
ifeq ($(KSUBLEVEL),19)
	echo "kernel check... OK"
else
	@echo "kernel check... UNSUPPORTED KERNEL DETECTED"
	exit 1;
endif
endif
endif
endif

# ====== END code for kernel_check

clean:
	$(KBUILD_BASE) clean
#echo rm -f -r *.mod.c .*cmd *.o *.ko .tmp_versions

# the following is only for convienience
# do not submit to Linus
# it's also called from the toplevel makefile

# INSTALL_MOD_DIR is set so that the drivers go into the correct location using Kbuild
# it defaults to 'extra' otherwise
INSTALL_MOD_DIR ?= kernel/drivers/scsi

# this allows packaging of modules
ifdef DESTDIR
INSTALL_MOD_PATH=$(DESTDIR)
else
INSTALL_MOD_PATH=
endif

# this evil rule ensures that the modules get build if you specify $(ko)
# as a dependancy.
ko = $(patsubst %.o,%.ko,$(obj-m))
$(ko): all

# now the actual command
install_kernel: $(ko)
	$(KBUILD_BASE) modules_install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH)

# vim: ft=make tw=72 sw=4 ts=4:

=== usr/Makefile ===
# This Makefile will work only with GNU make.

OSNAME=$(shell uname -s)

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build

KSUBLEVEL=$(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
			sed 's/^[ \t]*//;s/[ \t]*$$//')

ifeq ($(OSNAME),Linux)
	ifeq ($(KSUBLEVEL),11)
		IPC_CFLAGS=-DNETLINK_ISCSI=12
	else
	ifeq ($(KSUBLEVEL),12)
		IPC_CFLAGS=-DNETLINK_ISCSI=12
	else
		IPC_CFLAGS=-DNETLINK_ISCSI=8
	endif
	endif
IPC_OBJ=netlink.o
else
ifeq ($(OSNAME),FreeBSD)
IPC_CFLAGS=
IPC_OBJ=ioctl.o
endif
endif

OPTFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../include -D$(OSNAME) $(IPC_CFLAGS)
PROGRAMS = iscsid iscsiadm iscsistart

# sources shared between iscsid, iscsiadm and iscsistart
ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iscsi_sysfs.o
# sources shared between iscsid and iscsiadm
COMMON_SRCS =  $(ISCSI_LIB_SRCS) idbm.o
# core initiator files
INITIATOR_SRCS = initiator.o queue.o actor.o mgmt_ipc.o transport.o

all: $(PROGRAMS)

iscsid: $(COMMON_SRCS) $(IPC_OBJ) $(INITIATOR_SRCS) iscsid.o
	$(CC) $(CFLAGS) $^ -o $@

iscsiadm: $(COMMON_SRCS) strings.o discovery.o iscsiadm.o
	$(CC) $(CFLAGS) $^ -o $@

iscsistart: $(IPC_OBJ) $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) iscsistart.o \
		statics.o
	$(CC) $(CFLAGS) -static $^ -o $@

clean:
	rm -f *.o $(PROGRAMS)

## open-iscsi 2.0.865

=== Makefile ===
--- 
+++ 
@@ -15,9 +15,11 @@
 initddir = $(etcdir)/init.d
 
 MANPAGES = doc/iscsid.8 doc/iscsiadm.8 doc/iscsi_discovery.8
-PROGRAMS = usr/iscsid usr/iscsiadm utils/iscsi_discovery
+PROGRAMS = usr/iscsid usr/iscsiadm utils/iscsi_discovery \
+		   utils/fwparam_ibft/fwparam_ibft utils/iscsi-iname
 INSTALL = install
 ETCFILES = etc/iscsid.conf
+IFACEFILES = etc/iface.example
 
 # Random comments:
 # using '$(MAKE)' instead of just 'make' allows make to run in parallel
@@ -26,6 +28,8 @@
 all:
 	$(MAKE) -C usr
 	$(MAKE) -C kernel
+	$(MAKE) -C utils
+	$(MAKE) -C utils/fwparam_ibft
 	@echo
 	@echo "Compilation complete                Output file"
 	@echo "----------------------------------- ----------------"
@@ -34,22 +38,25 @@
 	@echo "Built iSCSI over TCP kernel module: kernel/iscsi_tcp.ko"
 	@echo "Built iSCSI daemon:                 usr/iscsid"
 	@echo "Built management application:       usr/iscsiadm"
+	@echo "Built utility:                      utils/fwparam_ibft/fwparam_ibft"
 	@echo
 	@echo Read README file for detailed information.
 
 clean:
+	$(MAKE) -C utils clean
 	$(MAKE) -C usr clean
 	$(MAKE) -C kernel clean
+	$(MAKE) -C utils/fwparam_ibft clean
 
 # this is for safety
 # now -jXXX will still be safe
 # note that make may still execute the blocks in parallel
 .NOTPARALLEL: install_usr install_programs install_initd \
 	install_initd_suse install_initd_redhat install_initd_debian \
-	install_etc install_doc install_kernel
+	install_etc install_iface install_doc install_kernel install_iname
 
 install: install_kernel install_programs install_doc install_etc \
-	install_initd
+	install_initd install_iname install_iface
 
 install_programs:  $(PROGRAMS)
 	$(INSTALL) -d $(DESTDIR)$(sbindir)
@@ -82,6 +89,10 @@
 	$(INSTALL) -m 755 etc/initd/initd.debian \
 		$(DESTDIR)$(initddir)/open-iscsi
 
+install_iface: $(IFACEFILES)
+	$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi/ifaces
+	$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi/ifaces
+
 install_etc: $(ETCFILES)
 	$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi
 	$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi
@@ -93,4 +104,13 @@
 install_kernel:
 	$(MAKE) -C kernel install_kernel
 
+install_iname:
+	if [ ! -f /etc/iscsi/initiatorname.iscsi ]; then \
+		echo "InitiatorName=`/sbin/iscsi-iname`" > /etc/iscsi/initiatorname.iscsi ; \
+		echo "***************************************************" ; \
+		echo "Setting InitiatorName to `cat /etc/iscsi/initiatorname.iscsi`" ; \
+		echo "To override edit /etc/iscsi/initiatorname.iscsi" ; \
+		echo "***************************************************" ; \
+	fi
+
 # vim: ft=make tw=72 sw=4 ts=4:

=== kernel/Makefile ===
#
# Makefile for the Linux Kernel iSCSI Initiator
#
# This Makefile invokes KBuild from outside the kernel directory when
# used from the main open-iscsi package. It also contains all of the
# KBuild stuff needed to build the modules.
#

# Kbuild stuff, the following is the only part of this file that KBuild
# actually uses itself.
EXTRA_CFLAGS += -I$(obj) -I$(obj)/../include 

ifeq ($(DEBUG_SCSI), 1)
EXTRA_CFLAGS += -DDEBUG_SCSI=1
endif

ifeq ($(DEBUG_TCP), 1)
EXTRA_CFLAGS += -DDEBUG_TCP=1
endif

obj-m				+= scsi_transport_iscsi.o
obj-m				+= libiscsi.o
obj-m				+= iscsi_tcp.o

# Everything beyond this point is used to call KBuild or handle support
# for multiple kernel versions.

# Kbuild verbosity
V ?= 0

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build
KBUILD_OUTPUT ?= 
# this is the basic Kbuild invocation, just append your make target
KBUILD_BASE = +$(MAKE) -C $(KSRC) M=`pwd` KBUILD_OUTPUT=$(KBUILD_OUTPUT) $(KARCH) V=$(V)

all: kernel_check
	$(KBUILD_BASE) modules

# ============ BEGIN code for kernel_check and source patching ================
# We calculate the Linux version for compilation. Than according to version,
# if needed, we patch source-code to match the compiling kernel.
# if you need a new kernel sub-version just add a target below.
#
# IMPORTANT: do "make clean" before submitting to SVN so source is in unpatched
#            form.

#some constants
13_patch=2.6.13_compat.patch
14to15_patch=2.6.14-and-2.6.15-compat.patch
16to18_patch=2.6.16-18_compat.patch
19_patch=2.6.19_compat.patch
all_patches=13_patch 14to15_patch 16to18_patch 19_patch
cur_patched=cur_patched

## fun stuff for maintaining multiple versions

# check to see if code is unpatched 
unpatch_code=$(shell test -e $(cur_patched) && echo do_unpatch_code )

KSUBLEVEL = $(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
		sed 's/^[ \t]*//;s/[ \t]*$$//')

KERNEL_TARGET=linux_2_6_$(KSUBLEVEL)
kernel_check: $(KERNEL_TARGET)


linux_2_6_13: has_13_patch

linux_2_6_14: has_14to15_patch

linux_2_6_15: has_14to15_patch

linux_2_6_16: has_16to18_patch

linux_2_6_17: has_16to18_patch

linux_2_6_18: has_16to18_patch

linux_2_6_19: has_19_patch

linux_2_6_20: $(unpatch_code)

linux_2_6_21: $(unpatch_code)

do_unpatch_code:
	echo "Un-patching source code for use with linux-2.6.20 and up ..."
	patch -R -E -p1 < $(cur_patched)
	rm -f `readlink $(cur_patched)`
	rm -f $(cur_patched)

# these below targets must be the same as the variable name prefixed by has_
# otherwise below compat_patch: target will not work
has_13_patch: $(13_patch)
	echo "Patching source code for linux-2.6.13 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(13_patch)
	cp $(13_patch) $@
	ln -s $@ $(cur_patched)

has_14to15_patch: $(14to15_patch)
	echo "Patching source code for linux-2.6.14-15 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(14to15_patch)
	cp $(14to15_patch) $@
	ln -s $@ $(cur_patched)

has_16to18_patch: $(16to18_patch)
	echo "Patching source code for linux-2.6.16-18 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(16to18_patch)
	cp $(16to18_patch) $@
	ln -s $@ $(cur_patched)

has_19_patch: $(19_patch)
	echo "Patching source code for linux-2.6.19 ..."
	if [ -e $(cur_patched) ]; then \
		make -C . clean; \
	fi
	patch -p1 < $(19_patch)
	cp $(19_patch) $@
	ln -s $@ $(cur_patched)

# ============ END code for kernel_check and source patching =================

clean: $(unpatch_code)
	$(KBUILD_BASE) clean
	rm -f Module.symvers

## The folowing compat_patch target is what we need to do to prepare a clean
# compat_patch set after new code is check-in to svn. To keep patches fuzzless.
# the new patches are writen into .new files so svn diff of next file will
# not trip on them.
compat_patch: $(unpatch_code)
	test -z "$(svn diff|head)" || { \
		echo "please run make compat_patch after changse are submited to svn"; \
		exit 1; \
	}
	for the_patch in all_patches ; do \
		make -C . has_$(the_patch); \
		svn diff > ${!the_patch}.new; \
	done

# the following is only for convienience
# do not submit to Linus
# it's also called from the toplevel makefile

# INSTALL_MOD_DIR is set so that the drivers go into the correct location using Kbuild
# it defaults to 'extra' otherwise
INSTALL_MOD_DIR ?= kernel/drivers/scsi

# this allows packaging of modules
ifdef DESTDIR
INSTALL_MOD_PATH=$(DESTDIR)
else
INSTALL_MOD_PATH=
endif

# this evil rule ensures that the modules get build if you specify $(ko)
# as a dependancy.
ko = $(patsubst %.o,%.ko,$(obj-m))
$(ko): all

# now the actual command
install_kernel: $(ko)
	$(KBUILD_BASE) modules_install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH)

# vim: ft=make tw=72 sw=4 ts=4:

=== usr/Makefile ===
--- 
+++ 
@@ -12,12 +12,12 @@
 
 ifeq ($(OSNAME),Linux)
 	ifeq ($(KSUBLEVEL),11)
-		IPC_CFLAGS=-DNETLINK_ISCSI=12
+		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
 	else
 	ifeq ($(KSUBLEVEL),12)
-		IPC_CFLAGS=-DNETLINK_ISCSI=12
+		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
 	else
-		IPC_CFLAGS=-DNETLINK_ISCSI=8
+		IPC_CFLAGS=-DNETLINK_ISCSI=8 -D_GNU_SOURCE
 	endif
 	endif
 IPC_OBJ=netlink.o
@@ -34,11 +34,11 @@
 PROGRAMS = iscsid iscsiadm iscsistart
 
 # sources shared between iscsid, iscsiadm and iscsistart
-ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iscsi_sysfs.o
+ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iscsi_sysfs.o idbm.o
 # sources shared between iscsid and iscsiadm
-COMMON_SRCS =  $(ISCSI_LIB_SRCS) idbm.o
+COMMON_SRCS =  $(ISCSI_LIB_SRCS)
 # core initiator files
-INITIATOR_SRCS = initiator.o queue.o actor.o mgmt_ipc.o transport.o
+INITIATOR_SRCS = initiator.o queue.o actor.o mgmt_ipc.o isns.o transport.o
 
 all: $(PROGRAMS)

=== utils/Makefile ===
# This Makefile will work only with GNU make.

CFLAGS += $(OPTFLAGS) -O2 -fno-inline -Wall -Wstrict-prototypes -g
PROGRAMS = iscsi-iname

all: $(PROGRAMS)

iscsi-iname: md5.o iscsi-iname.o
	$(CC) $(CFLAGS) $^ $(DBM_LIB) -o $@

clean:
	rm -f *.o $(PROGRAMS)

=== utils/fwparam_ibft/Makefile ===
OPTFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += $(OPTFLAGS) $(WARNFLAGS)
PROGRAMS = fwparam_ibft

all: $(PROGRAMS)

fwparam_ibft: fwparam_ibft.c fwparam_ibft.h
	$(CC) $(CFLAGS) $^ -o $@
clean:
	rm -f *.o $(PROGRAMS)

## open-iscsi 2.0.870~rc3

=== Makefile ===
--- 
+++ 
@@ -15,8 +15,7 @@
 initddir = $(etcdir)/init.d
 
 MANPAGES = doc/iscsid.8 doc/iscsiadm.8 doc/iscsi_discovery.8
-PROGRAMS = usr/iscsid usr/iscsiadm utils/iscsi_discovery \
-		   utils/fwparam_ibft/fwparam_ibft utils/iscsi-iname
+PROGRAMS = usr/iscsid usr/iscsiadm utils/iscsi_discovery utils/iscsi-iname
 INSTALL = install
 ETCFILES = etc/iscsid.conf
 IFACEFILES = etc/iface.example
@@ -26,10 +25,10 @@
 # over multiple makefile.
 
 all:
+	$(MAKE) -C utils/fwparam_ibft
 	$(MAKE) -C usr
 	$(MAKE) -C kernel
 	$(MAKE) -C utils
-	$(MAKE) -C utils/fwparam_ibft
 	@echo
 	@echo "Compilation complete                Output file"
 	@echo "----------------------------------- ----------------"
@@ -38,15 +37,14 @@
 	@echo "Built iSCSI over TCP kernel module: kernel/iscsi_tcp.ko"
 	@echo "Built iSCSI daemon:                 usr/iscsid"
 	@echo "Built management application:       usr/iscsiadm"
-	@echo "Built utility:                      utils/fwparam_ibft/fwparam_ibft"
 	@echo
 	@echo Read README file for detailed information.
 
 clean:
+	$(MAKE) -C utils/fwparam_ibft clean
 	$(MAKE) -C utils clean
 	$(MAKE) -C usr clean
 	$(MAKE) -C kernel clean
-	$(MAKE) -C utils/fwparam_ibft clean
 
 # this is for safety
 # now -jXXX will still be safe
@@ -56,6 +54,9 @@
 	install_etc install_iface install_doc install_kernel install_iname
 
 install: install_kernel install_programs install_doc install_etc \
+	install_initd install_iname install_iface
+
+install_usr: install_programs install_doc install_etc \
 	install_initd install_iname install_iface
 
 install_programs:  $(PROGRAMS)
@@ -78,6 +79,8 @@
 	$(INSTALL) -d $(DESTDIR)$(initddir)
 	$(INSTALL) -m 755 etc/initd/initd.suse \
 		$(DESTDIR)$(initddir)/open-iscsi
+	$(INSTALL) -m 755 etc/initd/boot.suse \
+		$(DESTDIR)$(initddir)/boot.open-iscsi
 
 install_initd_redhat:
 	$(INSTALL) -d $(DESTDIR)$(initddir)
@@ -94,8 +97,10 @@
 	$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi/ifaces
 
 install_etc: $(ETCFILES)
-	$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi
-	$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi
+	if [ ! -f /etc/iscsi/iscsid.conf ]; then \
+		$(INSTALL) -d $(DESTDIR)$(etcdir)/iscsi ; \
+		$(INSTALL) -m 644 $^ $(DESTDIR)$(etcdir)/iscsi ; \
+	fi
 
 install_doc: $(MANPAGES)
 	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
@@ -113,4 +118,9 @@
 		echo "***************************************************" ; \
 	fi
 
+depend:
+	for dir in usr utils utils/fwparam_ibft; do \
+		$(MAKE) -C $$dir $@; \
+	done
+
 # vim: ft=make tw=72 sw=4 ts=4:

=== kernel/Makefile ===
--- 
+++ 
@@ -48,11 +48,11 @@
 #            form.
 
 #some constants
-13_patch=2.6.13_compat.patch
-14to15_patch=2.6.14-and-2.6.15-compat.patch
-16to18_patch=2.6.16-18_compat.patch
-19_patch=2.6.19_compat.patch
-all_patches=13_patch 14to15_patch 16to18_patch 19_patch
+14to19_patch=2.6.14-19_compat.patch
+20to21_patch=2.6.20-21_compat.patch
+24_patch=2.6.24_compat.patch
+26_patch=2.6.26_compat.patch
+all_patches=14to21_patch 20to21_patch 24_patch 26_patch
 cur_patched=cur_patched
 
 ## fun stuff for maintaining multiple versions
@@ -63,71 +63,82 @@
 KSUBLEVEL = $(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
 		sed 's/^[ \t]*//;s/[ \t]*$$//')
 
+
 KERNEL_TARGET=linux_2_6_$(KSUBLEVEL)
 kernel_check: $(KERNEL_TARGET)
 
+linux_2_6_14: has_14to19_patch
 
-linux_2_6_13: has_13_patch
+linux_2_6_15: has_14to19_patch
 
-linux_2_6_14: has_14to15_patch
+linux_2_6_16: has_14to19_patch
 
-linux_2_6_15: has_14to15_patch
+linux_2_6_17: has_14to19_patch
 
-linux_2_6_16: has_16to18_patch
+linux_2_6_18: has_14to19_patch
 
-linux_2_6_17: has_16to18_patch
+linux_2_6_19: has_14to19_patch
 
-linux_2_6_18: has_16to18_patch
+linux_2_6_20: has_20to21_patch
 
-linux_2_6_19: has_19_patch
+linux_2_6_21: has_20to21_patch
 
-linux_2_6_20: $(unpatch_code)
+linux_2_6_22: has_20to21_patch
 
-linux_2_6_21: $(unpatch_code)
+linux_2_6_23: has_20to21_patch
+
+linux_2_6_24: has_24_patch
+
+linux_2_6_25: has_24_patch
+
+linux_2_6_26: has_26_patch
+
+linux_2_6_27: $(unpatch_code)
 
 do_unpatch_code:
-	echo "Un-patching source code for use with linux-2.6.20 and up ..."
+	echo "Un-patching source code for use with linux-2.6.14 and up ..."
 	patch -R -E -p1 < $(cur_patched)
 	rm -f `readlink $(cur_patched)`
 	rm -f $(cur_patched)
 
 # these below targets must be the same as the variable name prefixed by has_
 # otherwise below compat_patch: target will not work
-has_13_patch: $(13_patch)
-	echo "Patching source code for linux-2.6.13 ..."
+has_14to19_patch: $(14to19_patch)
+	echo "Patching source code for linux-2.6.14-19 ..."
 	if [ -e $(cur_patched) ]; then \
 		make -C . clean; \
 	fi
-	patch -p1 < $(13_patch)
-	cp $(13_patch) $@
+	patch -p1 < $(14to19_patch)
+	cp $(14to19_patch) $@
 	ln -s $@ $(cur_patched)
 
-has_14to15_patch: $(14to15_patch)
-	echo "Patching source code for linux-2.6.14-15 ..."
+has_20to21_patch: $(20to21_patch)
+	echo "Patching source code for linux-2.6.20-21 ..."
 	if [ -e $(cur_patched) ]; then \
 		make -C . clean; \
 	fi
-	patch -p1 < $(14to15_patch)
-	cp $(14to15_patch) $@
+	patch -p1 < $(20to21_patch)
+	cp $(20to21_patch) $@
 	ln -s $@ $(cur_patched)
 
-has_16to18_patch: $(16to18_patch)
-	echo "Patching source code for linux-2.6.16-18 ..."
+has_24_patch: $(24_patch)
+	echo "Patching source code for linux-2.6.24-25 ..."
 	if [ -e $(cur_patched) ]; then \
 		make -C . clean; \
 	fi
-	patch -p1 < $(16to18_patch)
-	cp $(16to18_patch) $@
+	patch -p1 < $(24_patch)
+	cp $(24_patch) $@
 	ln -s $@ $(cur_patched)
 
-has_19_patch: $(19_patch)
-	echo "Patching source code for linux-2.6.19 ..."
+has_26_patch: $(26_patch)
+	echo "Patching source code for linux-2.6.26 ..."
 	if [ -e $(cur_patched) ]; then \
 		make -C . clean; \
 	fi
-	patch -p1 < $(19_patch)
-	cp $(19_patch) $@
+	patch -p1 < $(26_patch)
+	cp $(26_patch) $@
 	ln -s $@ $(cur_patched)
+
 
 # ============ END code for kernel_check and source patching =================
 
@@ -173,4 +184,9 @@
 install_kernel: $(ko)
 	$(KBUILD_BASE) modules_install INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH)
 
+dpkg_divert:
+	for module in $(ko) ; do \
+		dpkg-divert --rename /lib/modules/$(KERNELRELEASE)/$(INSTALL_MOD_DIR)/$$module ; \
+	done
+
 # vim: ft=make tw=72 sw=4 ts=4:

=== usr/Makefile ===
--- 
+++ 
@@ -34,23 +34,30 @@
 PROGRAMS = iscsid iscsiadm iscsistart
 
 # sources shared between iscsid, iscsiadm and iscsistart
-ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iscsi_sysfs.o idbm.o
+ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iface.o idbm.o sysdeps.o sysfs.o iscsi_sysfs.o
 # sources shared between iscsid and iscsiadm
 COMMON_SRCS =  $(ISCSI_LIB_SRCS)
 # core initiator files
-INITIATOR_SRCS = initiator.o queue.o actor.o mgmt_ipc.o isns.o transport.o
+INITIATOR_SRCS = initiator.o scsi.o actor.o mgmt_ipc.o isns.o transport.o
+# fw boot files
+FW_BOOT_SRCS = $(wildcard ../utils/fwparam_ibft/*.o)
 
 all: $(PROGRAMS)
 
 iscsid: $(COMMON_SRCS) $(IPC_OBJ) $(INITIATOR_SRCS) iscsid.o
 	$(CC) $(CFLAGS) $^ -o $@
 
-iscsiadm: $(COMMON_SRCS) strings.o discovery.o iscsiadm.o
+iscsiadm: $(COMMON_SRCS) $(FW_BOOT_SRCS) strings.o discovery.o iscsiadm.o
 	$(CC) $(CFLAGS) $^ -o $@
 
-iscsistart: $(IPC_OBJ) $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) iscsistart.o \
-		statics.o
+iscsistart: $(IPC_OBJ) $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(FW_BOOT_SRCS) \
+		iscsistart.o statics.o
 	$(CC) $(CFLAGS) -static $^ -o $@
 
 clean:
-	rm -f *.o $(PROGRAMS)
+	rm -f *.o $(PROGRAMS) .depend
+
+depend:
+	gcc $(CFLAGS) -M `ls *.c` > .depend
+
+-include .depend

=== utils/fwparam_ibft/Makefile ===
#
#  Copyright (C) IBM Corporation. 2007
#  Author: Doug Maxey <dwm@austin.ibm.com>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#  Authors: Patrick Mansfield <patmans@us.ibm.com>
#	    Mike Anderson <andmike@us.ibm.com>
#	    Doug Maxey <dwm@austin.ibm.com>
#	    "Prasanna Mumbai" <mumbai.prasanna@gmail.com>
#

OBJS := fwparam_ibft.o fw_entry.o
OBJS += prom_lex.o prom_parse.tab.o fwparam_ppc.o
CLEANFILES = $(OBJS) *.output *~

OPTFLAGS ?= -O2 -g -fPIC
WARNFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../../include

all: $(OBJS)

clean:
	rm -f *.o $(CLEANFILES) .depend

$(OBJS): prom_parse.tab.h prom_parse.h fwparam_ibft.h

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

## open-iscsi 2.0.871

=== Makefile ===
--- 
+++ 
@@ -24,23 +24,35 @@
 # using '$(MAKE)' instead of just 'make' allows make to run in parallel
 # over multiple makefile.
 
-all:
+all: user kernel
+
+user: ;
+	$(MAKE) -C utils/sysdeps
 	$(MAKE) -C utils/fwparam_ibft
 	$(MAKE) -C usr
-	$(MAKE) -C kernel
 	$(MAKE) -C utils
 	@echo
-	@echo "Compilation complete                Output file"
-	@echo "----------------------------------- ----------------"
-	@echo "Built iSCSI Open Interface module:  kernel/scsi_transport_iscsi.ko"
-	@echo "Built iSCSI library module:         kernel/libiscsi.ko"
-	@echo "Built iSCSI over TCP kernel module: kernel/iscsi_tcp.ko"
-	@echo "Built iSCSI daemon:                 usr/iscsid"
-	@echo "Built management application:       usr/iscsiadm"
+	@echo "Compilation complete                 Output file"
+	@echo "-----------------------------------  ----------------"
+	@echo "Built iSCSI daemon:                  usr/iscsid"
+	@echo "Built management application:        usr/iscsiadm"
+	@echo "Built boot tool:                     usr/iscsistart"
 	@echo
-	@echo Read README file for detailed information.
+	@echo "Read README file for detailed information."
+
+kernel: force
+	$(MAKE) -C kernel
+	@echo "Kernel Compilation complete          Output file"
+	@echo "-----------------------------------  ----------------"
+	@echo "Built iSCSI Open Interface module:   kernel/scsi_transport_iscsi.ko"
+	@echo "Built iSCSI library module:          kernel/libiscsi.ko"
+	@echo "Built iSCSI over TCP library module: kernel/libiscsi_tcp.ko"
+	@echo "Built iSCSI over TCP kernel module:  kernel/iscsi_tcp.ko"
+
+force: ;
 
 clean:
+	$(MAKE) -C utils/sysdeps clean
 	$(MAKE) -C utils/fwparam_ibft clean
 	$(MAKE) -C utils clean
 	$(MAKE) -C usr clean
@@ -49,14 +61,14 @@
 # this is for safety
 # now -jXXX will still be safe
 # note that make may still execute the blocks in parallel
-.NOTPARALLEL: install_usr install_programs install_initd \
+.NOTPARALLEL: install_user install_programs install_initd \
 	install_initd_suse install_initd_redhat install_initd_debian \
 	install_etc install_iface install_doc install_kernel install_iname
 
 install: install_kernel install_programs install_doc install_etc \
 	install_initd install_iname install_iface
 
-install_usr: install_programs install_doc install_etc \
+install_user: install_programs install_doc install_etc \
 	install_initd install_iname install_iface
 
 install_programs:  $(PROGRAMS)

=== kernel/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 obj-m				+= scsi_transport_iscsi.o
 obj-m				+= libiscsi.o
+obj-m				+= libiscsi_tcp.o
 obj-m				+= iscsi_tcp.o
 
 # Everything beyond this point is used to call KBuild or handle support
@@ -48,11 +49,11 @@
 #            form.
 
 #some constants
-14to19_patch=2.6.14-19_compat.patch
-20to21_patch=2.6.20-21_compat.patch
+14to23_patch=2.6.14-23_compat.patch
 24_patch=2.6.24_compat.patch
 26_patch=2.6.26_compat.patch
-all_patches=14to21_patch 20to21_patch 24_patch 26_patch
+27_patch=2.6.27_compat.patch
+all_patches=14to21_patch 20to21_patch 24_patch 26_patch 27_patch
 cur_patched=cur_patched
 
 ## fun stuff for maintaining multiple versions
@@ -67,25 +68,25 @@
 KERNEL_TARGET=linux_2_6_$(KSUBLEVEL)
 kernel_check: $(KERNEL_TARGET)
 
-linux_2_6_14: has_14to19_patch
-
-linux_2_6_15: has_14to19_patch
-
-linux_2_6_16: has_14to19_patch
-
-linux_2_6_17: has_14to19_patch
-
-linux_2_6_18: has_14to19_patch
-
-linux_2_6_19: has_14to19_patch
-
-linux_2_6_20: has_20to21_patch
-
-linux_2_6_21: has_20to21_patch
-
-linux_2_6_22: has_20to21_patch
-
-linux_2_6_23: has_20to21_patch
+linux_2_6_14: has_14to23_patch
+
+linux_2_6_15: has_14to23_patch
+
+linux_2_6_16: has_14to23_patch
+
+linux_2_6_17: has_14to23_patch
+
+linux_2_6_18: has_14to23_patch
+
+linux_2_6_19: has_14to23_patch
+
+linux_2_6_20: has_14to23_patch
+
+linux_2_6_21: has_14to23_patch
+
+linux_2_6_22: has_14to23_patch
+
+linux_2_6_23: has_14to23_patch
 
 linux_2_6_24: has_24_patch
 
@@ -93,7 +94,14 @@
 
 linux_2_6_26: has_26_patch
 
-linux_2_6_27: $(unpatch_code)
+linux_2_6_27: has_27_patch
+
+linux_2_6_28: $(unpatch_code)
+
+linux_2_6_29: $(unpatch_code)
+
+linux_2_6_30: $(unpatch_code)
+
 
 do_unpatch_code:
 	echo "Un-patching source code for use with linux-2.6.14 and up ..."
@@ -103,22 +111,13 @@
 
 # these below targets must be the same as the variable name prefixed by has_
 # otherwise below compat_patch: target will not work
-has_14to19_patch: $(14to19_patch)
-	echo "Patching source code for linux-2.6.14-19 ..."
-	if [ -e $(cur_patched) ]; then \
-		make -C . clean; \
-	fi
-	patch -p1 < $(14to19_patch)
-	cp $(14to19_patch) $@
-	ln -s $@ $(cur_patched)
-
-has_20to21_patch: $(20to21_patch)
-	echo "Patching source code for linux-2.6.20-21 ..."
-	if [ -e $(cur_patched) ]; then \
-		make -C . clean; \
-	fi
-	patch -p1 < $(20to21_patch)
-	cp $(20to21_patch) $@
+has_14to23_patch: $(14to23_patch)
+	echo "Patching source code for linux-2.6.14-23 ..."
+	if [ -e $(cur_patched) ]; then \
+		make -C . clean; \
+	fi
+	patch -p1 < $(14to23_patch)
+	cp $(14to23_patch) $@
 	ln -s $@ $(cur_patched)
 
 has_24_patch: $(24_patch)
@@ -137,6 +136,15 @@
 	fi
 	patch -p1 < $(26_patch)
 	cp $(26_patch) $@
+	ln -s $@ $(cur_patched)
+
+has_27_patch: $(27_patch)
+	echo "Patching source code for linux-2.6.27 ..."
+	if [ -e $(cur_patched) ]; then \
+		make -C . clean; \
+	fi
+	patch -p1 < $(27_patch)
+	cp $(27_patch) $@
 	ln -s $@ $(cur_patched)

=== usr/Makefile ===
--- 
+++ 
@@ -30,15 +30,18 @@
 
 OPTFLAGS ?= -O2 -g
 WARNFLAGS ?= -Wall -Wstrict-prototypes
-CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../include -D$(OSNAME) $(IPC_CFLAGS)
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../include -I. -D$(OSNAME) $(IPC_CFLAGS)
 PROGRAMS = iscsid iscsiadm iscsistart
 
+# libc compat files
+SYSDEPS_SRCS = $(wildcard ../utils/sysdeps/*.o)
 # sources shared between iscsid, iscsiadm and iscsistart
-ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iface.o idbm.o sysdeps.o sysfs.o iscsi_sysfs.o
+ISCSI_LIB_SRCS = util.o io.o auth.o login.o log.o md5.o sha1.o iface.o idbm.o sysfs.o host.o session_info.o iscsi_sysfs.o $(SYSDEPS_SRCS)
 # sources shared between iscsid and iscsiadm
 COMMON_SRCS =  $(ISCSI_LIB_SRCS)
 # core initiator files
-INITIATOR_SRCS = initiator.o scsi.o actor.o mgmt_ipc.o isns.o transport.o
+INITIATOR_SRCS = initiator.o scsi.o actor.o event_poll.o mgmt_ipc.o isns.o \
+		cxgb3i.o transport.o
 # fw boot files
 FW_BOOT_SRCS = $(wildcard ../utils/fwparam_ibft/*.o)
 
@@ -53,9 +56,8 @@
 iscsistart: $(IPC_OBJ) $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(FW_BOOT_SRCS) \
 		iscsistart.o statics.o
 	$(CC) $(CFLAGS) -static $^ -o $@
-
 clean:
-	rm -f *.o $(PROGRAMS) .depend
+	rm -f *.o $(PROGRAMS) .depend $(LIBSYS)
 
 depend:
 	gcc $(CFLAGS) -M `ls *.c` > .depend

=== utils/fwparam_ibft/Makefile ===
--- 
+++ 
@@ -21,13 +21,14 @@
 #	    "Prasanna Mumbai" <mumbai.prasanna@gmail.com>
 #
 
-OBJS := fwparam_ibft.o fw_entry.o
+SYSDEPS_OBJS = $(wildcard ../sysdeps/*.o)
+OBJS := fw_entry.o fwparam_ibft_sysfs.o $(SYSDEPS_OBJS)
 OBJS += prom_lex.o prom_parse.tab.o fwparam_ppc.o
 CLEANFILES = $(OBJS) *.output *~
 
 OPTFLAGS ?= -O2 -g -fPIC
 WARNFLAGS ?= -Wall -Wstrict-prototypes
-CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../../include
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../../include -I../../usr
 
 all: $(OBJS)

## open-iscsi 2.0.871.3

=== kernel/Makefile ===
--- 
+++ 
@@ -102,6 +102,9 @@
 
 linux_2_6_30: $(unpatch_code)
 
+linux_2_6_31: $(unpatch_code)
+
+linux_2_6_32: $(unpatch_code)
 
 do_unpatch_code:
 	echo "Un-patching source code for use with linux-2.6.14 and up ..."

=== usr/Makefile ===
--- 
+++ 
@@ -41,7 +41,7 @@
 COMMON_SRCS =  $(ISCSI_LIB_SRCS)
 # core initiator files
 INITIATOR_SRCS = initiator.o scsi.o actor.o event_poll.o mgmt_ipc.o isns.o \
-		cxgb3i.o transport.o
+		cxgb3i.o be2iscsi.o transport.o
 # fw boot files
 FW_BOOT_SRCS = $(wildcard ../utils/fwparam_ibft/*.o)

=== debian/changelog ===
open-iscsi (2.0.871.3-2squeeze1) unstable; urgency=low

  * Add patch to support NICs that have native iSCSI support. Thanks to
    Bjoern Metzdorf for the patch. (Closes: #514924) 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 25 Oct 2010 02:57:58 +0530

open-iscsi (2.0.871.3-2) unstable; urgency=low

  * Break down and add quilt patches
    + 003_Fix-CVE-2009-1297.patch
    + 004_make-iscsistart-a-dynamic-binary.patch
  * Add some explanation about initiatorname.iscsi into README.Debian
    (Closes: #507003) 
  * Fix double variable assignment in initramfs.local-top. Thanks to Aurelien
    Jarno (Closes: #576786) 
  * Document the odd hang behavior during iSCSI login phase when using 32 bit
    open-iscsi with 64 bit kernel 
  * Change address to my official Debian address and remove the DMUA flag
  * Handle iSCSI LVM devices and devices marked _netdev (Closes: #498616) 
  * Switch to 3.0 (quilt) source format 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 11 Jun 2010 12:33:02 +0530

open-iscsi (2.0.871.3-1) unstable; urgency=low

  * New upstream release (Closes: #564012, #566511) 
  * When open-iscsi service is asked to stop, attempt to umount all iSCSI
    devices. On failure, bail out (Closes: #501580, #499126) 
  * Add debian/source/format specifying the current source format 

 -- Ritesh Raj Sarraf <rrs@researchut.com>  Wed, 24 Mar 2010 21:44:38 +0530

open-iscsi (2.0.871-1) unstable; urgency=low

  [ Guido Günther ]
  * Imported Upstream version 2.0.871

  [ Ritesh Raj Sarraf ]
  * New Upstream Release - 2.0.871
    (Closes: #424642)
  * Fix credential passing in local-top/initramfs.local-top
    (Closes: #550012, #525053)
  * Fix settling of devices in initramfs (Closes: #501582, #488999)
  * Update Standards-Version to 3.8.4
  * Change to team maintenance
  * Add git-orig-source target
  * Add debian/watch file
  * Add README.source file
  * Add quilt patches
  * Add Vcs headers
  * Update debhelper to v7
  * Update copyright information
  * Improve description (Closes: #504707)
  * Stop umountiscsi and open-iscsi in runlevel 1
  * Remove already obsolete disabled-install-indep target
  * Replace deprecated dh_clean -k with dh_prep
  * Refresh 001_manpages_fixes.patch
  * Fix copyright and explain packaging licensing
  * Fix "undefined reference to strl* when building iscsid"
  * Proper sanity check in the init script for empty strings
    (Closes: #501319)
  * Provide init script service with the same name
  * Build iscsistart as a dynamic binary

 -- Ritesh Raj Sarraf <rrs@researchut.com>  Sat, 06 Feb 2010 20:28:23 +0530

open-iscsi (2.0.870~rc3-0.6) unstable; urgency=low

  * Non-maintainer upload.
  * [4bfddee] Fix CVE-2009-1297 (Closes: #547011) - thanks to Colin Watson for
    the patch

 -- Guido Günther <agx@sigxcpu.org>  Sat, 23 Jan 2010 17:56:18 +0100

open-iscsi (2.0.870~rc3-0.5) unstable; urgency=low

  * Non-maintainer upload to fix release goal.
  * Fix incorrect provides and dependencies in init.d script (Closes:
    #541390).
  * Add missing package dependency on udev.  Rewrite init.d script to use
    'udevadm settle' instead of obsolete 'udevsettle' (Closes: #517225).
  * No longer ignore errors in the postinst.  Tip from lintian.
  * Do not start open-iscsi init.d script during package installation,
    to avoid installation problem (Closes: #529280).

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 13 Sep 2009 20:25:49 +0200

open-iscsi (2.0.870~rc3-0.4) unstable; urgency=medium

  * Clean up diff.gz, it downgraded the package to 2.0.869.2.
    (closes: #507496)

 -- Norbert Tretkowski <nobse@debian.org>  Thu,  8 Jan 2009 11:19:23 +0100

open-iscsi (2.0.870~rc3-0.3) unstable; urgency=low

  * Non-maintainer upload.
  * Do not exit with return code 1 in init script, because it breaks
    upgrades and is a policy violation (Closes: #503070)

 -- Patrick Schoenfeld <schoenfeld@debian.org>  Mon, 27 Oct 2008 10:21:17 +0100

open-iscsi (2.0.870~rc3-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Drop patch from iscsistart.c which breaks booting from iscsi.
    (closes: #499508)
  * Drop patch from version.h which adds an outdated upstream version
    number.

 -- Norbert Tretkowski <nobse@debian.org>  Fri, 10 Oct 2008 10:46:56 +0200

open-iscsi (2.0.870~rc3-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release
    - Adds support for Linux 2.6.26 (Closes: #499508)
  * Fix ">&" redirection bashism in open-iscsi initscript.

 -- Chris Lamb <lamby@debian.org>  Tue, 30 Sep 2008 21:40:27 +0100

open-iscsi (2.0.869.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix bashism in debian/rules (Closes: #484427)
    - Move upstream URL to Homepage field.
    - Bump Standards-Version to 3.8.0.

 -- Chris Lamb <chris@chris-lamb.co.uk>  Fri, 11 Jul 2008 23:20:18 +0100

open-iscsi (2.0.869.2-2) unstable; urgency=low

  * Revert if-up.d approach for logging into automatic targets; just
    start open-iscsi at rcS.d/S45, and mount _netdev filesystems when
    open-iscsi is started.
  * Call udevsettle before mounting

 -- Philipp Hug <debian@hug.cx>  Mon, 12 May 2008 12:48:49 +0200

open-iscsi (2.0.869.2-1) unstable; urgency=low

  * New upstream release

 -- Philipp Hug <debian@hug.cx>  Mon, 12 May 2008 11:56:30 +0200

open-iscsi (2.0.869~rc4-1) experimental; urgency=low

  * init script: If /sys is not mounted return without error
    (Closes: #470434, #423368)
  * Merged changes by Andrew Moise <chops@demiurgestudios.com>
  * Adding Andrew as Co-Maintainer
  * New upstream release (Closes: #474167)
  * Added flex and bison build-depends
  * Fixed up init scripts to attempt to handle automatic mounting and
    unmounting properly (Closes: #423851, #438542)
  * Added /etc/network/if-up.d/000open-iscsi to start automatic targets
  * Parameterized /etc/iscsi/initiatorname.iscsi in init script,
    correcting one place where it still said /etc/initiatorname.iscsi
  * Updated README.Debian


=== debian/control ===
Source: open-iscsi
Section: net
Priority: optional
Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
Uploaders: Andrew Moise <chops@demiurgestudios.com>, Philipp Hug <debian@hug.cx>, Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 7.0.0), bzip2, bison, flex
Standards-Version: 3.8.4
Vcs-Git: git://git.debian.org/git/pkg-iscsi/open-iscsi.git
Vcs-Browser: http://git.debian.org/?p=pkg-iscsi/open-iscsi.git
Homepage: http://www.open-iscsi.org/

Package: open-iscsi
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Description: High performance, transport independent iSCSI implementation
 Open-iSCSI is a high-performance, transport independent, multi-platform
 implementation of RFC3720 iSCSI
 .
 Open-iSCSI is partitioned into user and kernel parts where the kernel
 portion implements iSCSI data path (i.e. iSCSI Read and iSCSI Write)
 The userspace contains the entire control plane consisting of:
  * Configuration Manager
  * iSCSI Discovery, Login and Logout processing
  * Connection level error processing
  * Nop-In and Nop-Out handling
  * Text processing, iSNS, SLP, Radius et cetera (future)
 .
 The userspace component consists of a daemon, iscsid and a management
 utility, iscsiadm

#Package: linux-iscsi-modules-source
#Architecture: all
#Depends: ${shlibs:Depends}, ${misc:Depends}, module-assistant, debhelper (>= 4.0.0), bzip2
#Description: Source Code for the Linux iSCSI Kernel Modules
# Along with make-kpkg, this package maybe used to build a linux-iscsi-modules 
# package for a kernel-image package.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


# get-orig-source target
DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

get-orig-source:
	[ ! -f $(ORIG_FILE).gz ] || rm -f $(ORIG_FILE).gz
	uscan --force-download --rename --repack --download-version=$(DEB_UPSTREAM_VERSION) --destdir=.


CFLAGS = -Wall -g
export OPTFLAGS =-DDISCOVERY_FILE=\"/var/lib/open-iscsi/discovery\" -DNODE_FILE=\"/var/lib/open-iscsi/node\"

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


#Architecture 
build: build-arch

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 

	# Add here commands to compile the arch part of the package.
	$(MAKE) -C utils/fwparam_ibft
	$(MAKE) user
	$(MAKE) -C utils

	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp 

	# Add here commands to compile the indep part of the package.
	#$(MAKE) doc
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) -C utils/fwparam_ibft clean
	$(MAKE) -C usr clean
	$(MAKE) -C utils clean
	rm -rf modules

	dh_clean 

install: install-arch
# disabled kernel module package for now because source is already in debian stock kernelsy
install-indep:

install-arch:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -s

	# Add here commands to install the arch part of the package into 
	# debian/open-iscsi.
	install -m 755 usr/iscsiadm $(CURDIR)/debian/open-iscsi/usr/bin
	install -m 755 usr/iscsid $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 755 usr/iscsistart $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 755 utils/iscsi_discovery $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 755 utils/iscsi-iname $(CURDIR)/debian/open-iscsi/usr/sbin
	install -m 644 debian/initiatorname.iscsi $(CURDIR)/debian/open-iscsi/etc/iscsi/initiatorname.iscsi
	install -m 644 etc/iscsid.conf $(CURDIR)/debian/open-iscsi/etc/iscsi
	install -m 644 debian/open-iscsi.default $(CURDIR)/debian/open-iscsi/etc/default/open-iscsi

	# initramfs stuff
	install -m 755 debian/extra/initramfs.hook \
		$(CURDIR)/debian/open-iscsi/usr/share/initramfs-tools/hooks/iscsi
	install -m 755 debian/extra/initramfs.local-top \
		$(CURDIR)/debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/iscsi

	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installinit -u 'start 45 S . stop 81 0 1 6 .' --no-start
	dh_installinit -u 'stop 80 0 1 6 .' --no-start --name=umountiscsi.sh
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
#	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure get-orig-source
